# NGSpy 6.2 file created by SEQUOIA CellCap3D V21.2 (Build 2021/08/04) on Wednesday, 18 August, 2021
import time
from ngsolve import *
from netgen.csg import *
t0 = time.perf_counter()
p1 = Plane (Pnt(0,0,-0.1), Vec(0,0,-1) )
p2 = Plane (Pnt(0,0,-0.1+2.0), Vec( 0,0,1) )
p3 = Plane (Pnt(0,1.0,0), Vec(0,-1,0) )
p3s = Plane (Pnt(0,1.0+0.01,0), Vec(0,-1,0) )
p4 = Plane (Pnt(0, 1.0+1.0, 0), Vec(0, 1,0) )
p4s = Plane (Pnt(0, 1.0+1.0-0.01, 0), Vec(0, 1,0) )
p5 = Plane (Pnt(1.0, 0, 0), Vec(-1, 0, 0) )
p5s = Plane (Pnt(1.0+0.01, 0, 0), Vec(-1, 0, 0) )
p6 = Plane (Pnt(1.0+1.0, 0, 0), Vec(1, 0, 0) )
p6s = Plane (Pnt(1.0+1.0-0.01, 0, 0), Vec(1, 0, 0) )
planes = p1 * p2 * p3 * p4 * p5 * p6
planess = p1 * p2 * p3s * p4s * p5s * p6s
path = SplineCurve3d()
path.AddPoint (0,0,10)
path.AddPoint (0,0,-10)
path.AddSegment (0,1)
bot_M1   = Plane (Pnt(0,0,0.251), Vec(0,0, -1) )
top_M1   = Plane (Pnt(0,0,0.349), Vec(0,0, 1) )
splineM1_1 = SplineCurve2d()
splineM1_1.AddPoint(1,2)
splineM1_1.AddPoint(2,2)
splineM1_1.AddPoint(2,1)
splineM1_1.AddPoint(1,1)
splineM1_1.AddSegment(0,1)
splineM1_1.AddSegment(1,2)
splineM1_1.AddSegment(2,3)
splineM1_1.AddSegment(3,0)
M1_1 = planess * top_M1 * bot_M1 * Extrusion(path,splineM1_1,Vec(0,1,0)).mat("M1_1").maxh(0.05)
bot_M2   = Plane (Pnt(0,0,1.351), Vec(0,0, -1) )
top_M2   = Plane (Pnt(0,0,1.4490000000000003), Vec(0,0, 1) )
splineM2_1 = SplineCurve2d()
splineM2_1.AddPoint(1,2)
splineM2_1.AddPoint(2,2)
splineM2_1.AddPoint(2,1)
splineM2_1.AddPoint(1,1)
splineM2_1.AddSegment(0,1)
splineM2_1.AddSegment(1,2)
splineM2_1.AddSegment(2,3)
splineM2_1.AddSegment(3,0)
M2_1 = planess * top_M2 * bot_M2 * Extrusion(path,splineM2_1,Vec(0,1,0)).mat("M2_1").maxh(0.05)
bot_L1   = Plane (Pnt(0,0,2.001), Vec(0,0, -1) )
top_L1   = Plane (Pnt(0,0,2.099), Vec(0,0, 1) )
bot_L2   = Plane (Pnt(0,0,2.101), Vec(0,0, -1) )
top_L2   = Plane (Pnt(0,0,2.1990000000000003), Vec(0,0, 1) )
geo = CSGeometry()
dielectric = (planes - M1_1 - M2_1).mat("dielectric")
geo.Add(dielectric.maxh(0.5).col([0,1,0]).transp())
reg0  = M1_1
geo.Add(reg0 , bcmod=[(reg0,'0')])
reg1  = M2_1
geo.Add(reg1 , bcmod=[(reg1,'1')])
geo.PeriodicSurfaces(p3,p4)
geo.PeriodicSurfaces(p5,p6)
geo.Draw()
Redraw()
from ngsolve import *
mesh = Mesh(geo.GenerateMesh())
#mesh.ngmesh.Save("mesh.vol")
tmesh = time.perf_counter()
print(f"Generate Mesh {tmesh - t0:0.4f} seconds")
print(mesh.GetBoundaries())
print("materials = ", mesh.GetMaterials())
electrodes = ["0","1",]
# NGSpy 6.2 file created by SEQUOIA CellCap3D V21.2 (Build 2021/08/04) on Wednesday, 18 August, 2021
import time
from netgen.csg import *
from ngsolve import *
#mesh = Mesh("mesh.vol.gz")
#geo = CSGeometry("export.geo")
#ngmesh = geo.GenerateMesh()
#mesh = Mesh(ngmesh)
#print(mesh.GetBoundaries())
#print(mesh.GetMaterials())
# fout = open("/home/valery/work/scd/examples/SCD_examples/capmatcap_test.txt", "w")
fout = open("capmatcap_test.txt", "w")
fout.write(f"# Capacitance Matrix generated by SEQUOIA CellCap3D V21.2 (Build 2021/08/04) on Wednesday, 18 August, 2021\n")
#fout.write(f"# electrodes = 0|1|\n")
# H1-conforming finite element space
fes = Periodic(H1(mesh, order=3, dirichlet="0|1|"))
# define trial- and test-functions
u = fes.TrialFunction()
v = fes.TestFunction()
# the right hand side
f = LinearForm(fes)
f += 0 * v * dx
# the bilinear-form
a = BilinearForm(fes, symmetric=True)
a += grad(u)*grad(v)*dx
#c = Preconditioner(a,"multigrid")
c = Preconditioner(a,"local")
#c = Preconditioner(a,"direct")
a.Assemble()
f.Assemble()
t1 = time.perf_counter()
print(f"Assemble {(t1 - t0):0.4f} seconds")
normals = -CoefficientFunction (specialcf.normal(3))
ntot = 2
for elec in range(0,ntot):
     t2 = time.perf_counter()
     print("elec=", electrodes[elec], elec)
# the solution field
     gfu = GridFunction(fes)
     gfu.Set(1.0, definedon=mesh.Boundaries(electrodes[elec]))
     BVP(bf=a, gf=gfu, lf=f, pre=c, maxsteps=200).Do()
     Draw(gfu, mesh, "u"+electrodes[elec])
     t3 = time.perf_counter()
     print(f"BVP{elec} {(t3 - t2):0.1f} seconds")
     print("starting gfE.Set( -grad(gfu))")

     # electric field only defined in dielectric:
     fes_flux = HDiv(mesh, order=3), definedon="dielectric")
     gfE = GridFunction(fes_flux)
     
     gfE.Set( -grad(gfu))
     # alternatively, you could restrict interpolation to dielectric region:
     # gfE.Set( -grad(gfu), definedon=mesh.Materials("dielectric"))
     
     Draw(gfE, mesh, "E")
     fout.write(f"{electrodes[elec]} ")
     sum=0
     for i in range(0, ntot):
         charge = (Integrate(sqrt((gfE*normals)**2), mesh, definedon=mesh.Boundaries(electrodes[i])))
#         charge = (Integrate((gfE*normals), mesh, definedon=mesh.Boundaries(electrodes[i])))
         if elec != i :
             charge = -charge
         print ("Integral = ", charge)
         sum += charge
         fout.write(f"{charge:0.4f} ")
     fout.write(f"{sum:0.4f}\n")
     print("sum=",sum)
     t4 = time.perf_counter()
     print(f"elec{elec} {t4 - t3:0.1f} seconds")
t5 = time.perf_counter()
fout.write(f"# capmat calculation time {(t3 - t1):0.1f} seconds\n")
fout.write(f"# overall time including meshing and capmat calculation {(t5 - t0):0.1f} seconds\n")
fout.close()
#quit()

